/* =====================================================================

   LiMo - Liblary
      Sync Main System.  - ȷС(ġå)

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Apr.01.2000  ƤǺ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ᥤץʤ
  RRMain              -- ֤˥뤵ᥤ
  RRMainFree          -- ᥤץཪλ()
  RRMainWindowSize    -- եå
  RRMainInterval      -- ߻֤
  RRMainIntervalTime  -- ߻֤ɤߤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "rr_spriteman.h"

/* --- եåǡ */
#include  "../picture/akari.xpm"
#include  "../picture/multi.xpm"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  INTERVAL   12

/* --- ᥤ󥹥ƥåץ٥ */
enum {
  ST_INIT = 0,
  ST_AKARI_START,
  ST_AKARI_IN,
  ST_AKARI_WAIT,
  ST_AKARI_OUT,
  ST_MULTI_START,
  ST_MULTI_IN,
  ST_MULTI_WAIT,
  ST_MULTI_OUT
};

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void   picture_step(void);
void   picture_work(gint, gint);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥץ쥤ݻ */
static gint  fw, fh;

/* --- ߤγ */
static gint  interval;
static gint  int_handle;
static gint  timer;

/* --- ǡ */
static GdkPixbuf  *akari = NULL, *multi = NULL;
static GdkPixbuf  *tmpbuf = NULL;
static GdkPixmap  *chr = NULL;

/* --- ץ饤ȥǡ */
static RRSObj  *spr1;

/* --- ץ饤ȥǡ */
static gint  disp_x, disp_y, dx, dy;

/* --- ƥåץ */
static gint  step;

/* --- եɥ */
static gint  wait;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  int_handle = 0;

  timer = 0;

  RRScreenFontSetInit("-adobe-times-bold-r-normal-*-16-*-*-*-*-*-*-*,\
            -*-*-medium-*-normal-*-16-*-*-*-*-*-jisx0208.1983-0");

  RRSpritemanInit();
  RRSpritemanBGColor(0xffff, 0xffff, 0xffff);

  /* -- եåǡ */
  akari = gdk_pixbuf_new_from_xpm_data((const char **)akari_xpm);
  multi = gdk_pixbuf_new_from_xpm_data((const char **)multi_xpm);
  tmpbuf = gdk_pixbuf_new(GDK_COLORSPACE_RGB, FALSE, 8, 200, 285);

  /* -- GdkRGB ν */
  gdk_rgb_init();

  /* -- ߳ */
  RRMainInterval(INTERVAL);

  /* -- ץ饤Ƚ */
  spr1 = RRSpritemanNew();
  spr1->sw = FALSE;

  /* --  */
  RRMainWindowSize(320, 200);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (akari != NULL) gdk_pixbuf_unref(akari);
  if (multi != NULL) gdk_pixbuf_unref(multi);
  if (tmpbuf != NULL) gdk_pixbuf_unref(tmpbuf);
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  RRMainWindowSize   -- եå

   return : void
   void
-------------------------------------------------------------- */
void       RRMainWindowSize(gint w, gint h)
{
  GtkWidget *screen;

  fw = w;
  fh = h;

  screen = RRScreenCanvas();
  RRScreenGCColor(0xffff, 0xffff, 0xffff);
  RRScreenRectangle((gint)TRUE, 0, 0, fw, fh);
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMain           -- ֤˥뤵ᥤ

   return : void
   void
-------------------------------------------------------------- */
gint RRMain(gpointer gdata)
{
  timer++;

  /* --- 饯γɽ */
  picture_step();

  /* ---  */
  RRSpritemanUpdate();

  /* --- Graphic Buffer Υå */
  if (RRScreenWindow() != NULL) {
    RRScreenSwitch();
  }
  else {
    RRScreenSwitchRoot();
  }

  return 1;
}



/* --------------------------------------------------
   ᥤ󥵥ݡ
----------------------------------------------------- */
void   picture_step(void)
{
  switch(step) {
  case ST_INIT:
    disp_x = disp_y = 0;
    dx = dy = 2;
    step = ST_AKARI_START;

  case ST_AKARI_START:
    wait = 25;
    step = ST_AKARI_IN;

  case ST_AKARI_IN:
    picture_work(0, (255 * (25 - wait) / 25));
    wait--;
    if (wait == 0) {
      wait = 30;
      step = ST_AKARI_WAIT;
    }
    break;

  case ST_AKARI_WAIT:
    picture_work(0, 255);
    wait--;
    if (wait == 0) {
      wait = 25;
      step = ST_AKARI_OUT;
    }
    break;

  case ST_AKARI_OUT:
    picture_work(0, (255 * wait / 25));
    wait--;
    if (wait == 0) {
      step = ST_MULTI_START;
    }
    break;

  case ST_MULTI_START:
    wait = 25;
    step = ST_MULTI_IN;

  case ST_MULTI_IN:
    picture_work(1, (255 * (25 - wait) / 25));
    wait--;
    if (wait == 0) {
      wait = 30;
      step = ST_MULTI_WAIT;
    }
    break;

  case ST_MULTI_WAIT:
    picture_work(1, 255);
    wait--;
    if (wait == 0) {
      wait = 25;
      step = ST_MULTI_OUT;
    }
    break;

  case ST_MULTI_OUT:
    picture_work(1, (255 * wait / 25));
    wait--;
    if (wait == 0) {
      step = ST_AKARI_START;
    }
    break;
  }
}


/* --------------------------------------------------
   ᥤ󥵥ݡ
----------------------------------------------------- */
void   picture_work(gint pic, gint fade)
{
  GdkPixbuf  *select;
  guchar  *fill;
  gint  i, j;
  gint  w, h;

  w = gdk_pixbuf_get_width(tmpbuf);
  h = gdk_pixbuf_get_height(tmpbuf);

  fill = (guchar*)gdk_pixbuf_get_pixels(tmpbuf);
  for(j=0; j<h; j++) {
    for(i=0; i<w; i++) {
      *fill = 0xff;
      fill++;
      *fill = 0xff;
      fill++;
      *fill = 0xff;
      fill++;
    }
  }

  /* --- ư */
  disp_x += dx;
  disp_y += dy;
  if (disp_x < 0) dx = -dx;
  if (disp_y < 0) dy = -dy;
  if (disp_x > (fw - w)) dx = -dx;
  if (disp_y > (fh - h)) dy = -dy;

  /* ---  */
  switch(pic) {
  case 1:
    select = multi;
    break;
  default:
    select = akari;
    break;
  }
  gdk_pixbuf_composite(select, tmpbuf,
		       0, 0, w, h, 0, 0, 1.0, 1.0,
		       GDK_INTERP_NEAREST, (fade % 256));

  /* --- X Window ɽ */
  if (chr != NULL) gdk_pixmap_unref(chr);
  gdk_pixbuf_render_pixmap_and_mask(tmpbuf, &chr, NULL, 0x80);
  spr1->sw = TRUE;
  spr1->update = TRUE;
  spr1->z = 10;
  spr1->obj.sw = TRUE;
  spr1->obj.mask_offset = TRUE;
  spr1->obj.objmap = chr;
  spr1->obj.objmask = NULL;
  spr1->obj.x = disp_x;
  spr1->obj.y = disp_y;
  spr1->obj.w = w;
  spr1->obj.h = h;
  spr1->obj.ox = 0;
  spr1->obj.oy = 0;
  spr1->obj.offset_x = 0;
  spr1->obj.offset_y = 0;
}
